function getShortcutStringRepresentation(event) {
	var modifiersArray = {
			altGraphKey:event.altGraphKey,
			altKey:event.altKey,
			ctrlKey:event.ctrlKey,
			metaKey:event.metaKey,
			shiftKey:event.shiftKey
		}
	var modifiers="";
	for(var prop in modifiersArray) {
		if (modifiersArray.hasOwnProperty(prop)) {
			if (modifiersArray[prop]==true) {
				modifiers+=prop.replace("Key","").toUpperCase()+"+";
			}
		}
	}
	if (modifiers == "" && event.keyCode ==8)
		return "";
	var keyName = fromKeyCode(event.keyCode,event.shiftKey);
	if (["Alt","Ctrl","Shift","META|Command"].indexOf(keyName)!==-1)
		keyName="";
	return modifiers+keyName;
}

function fromKeyCode (n,shiftKey) {
	if( 47<=n && n<=90 ) return unescape('%'+(n).toString(16))
	if( 96<=n && n<=105) return 'NUM '+(n-96)
	if(112<=n && n<=135) return 'F'+(n-111)

	if(n==3)  return 'Cancel' //DOM_VK_CANCEL
	if(n==6)  return 'Help'   //DOM_VK_HELP
	if(n==8)  return 'Backspace'
	if(n==9)  return 'Tab'
	if(n==12) return 'NUM 5'  //DOM_VK_CLEAR
	if(n==13) return 'Enter'
	if(n==16) return 'Shift'
	if(n==17) return 'Ctrl'
	if(n==18) return 'Alt'
	if(n==19) return 'Pause|Break'
	if(n==20) return 'CapsLock'
	if(n==27) return 'Esc'
	if(n==32) return 'Space'
	if(n==33) return 'PageUp'
	if(n==34) return 'PageDown'
	if(n==35) return 'End'
	if(n==36) return 'Home'
	if(n==37) return 'Left Arrow'
	if(n==38) return 'Up Arrow'
	if(n==39) return 'Right Arrow'
	if(n==40) return 'Down Arrow'
	if(n==42) return '*' //Opera
	if(n==43) return '+' //Opera
	if(n==44) return 'PrntScrn'
	if(n==45) return 'Insert'
	if(n==46) return 'Delete'

	if(n==91) return 'WIN Start'
	if(n==92) return 'WIN Start Right'
	if(n==93) return 'WIN Menu'
	if(n==106) return '*'
	if(n==107) return '+'
	if(n==108) return 'Separator' //DOM_VK_SEPARATOR
	if(n==109) return '-'
	if(n==110) return '.'
	if(n==111) return '/'
	if(n==144) return 'NumLock'
	if(n==145) return 'ScrollLock'

	//Media buttons (Inspiron laptops) 
	if(n==173) return 'Media Mute On|Off'
	if(n==174) return 'Media Volume Down'
	if(n==175) return 'Media Volume Up'
	if(n==176) return 'Media >>'
	if(n==177) return 'Media <<'
	if(n==178) return 'Media Stop'
	if(n==179) return 'Media Pause|Resume'

	if(n==182) return 'WIN My Computer'
	if(n==183) return 'WIN Calculator'
	if(n==186) return !shiftKey?';':':'
	if(n==187) return !shiftKey?'=':'+'
	if(n==188) return !shiftKey?',':'<'
	if(n==189) return !shiftKey?'-':'_'
	if(n==190) return !shiftKey?'.':'>'
	if(n==191) return !shiftKey?'/':'?'
	if(n==192) return !shiftKey?'\`':'~'
	if(n==219) return !shiftKey?'[':'{'
	if(n==220) return !shiftKey?'\\':'|'
	if(n==221) return !shiftKey?']':'}'
	if(n==222) return !shiftKey?'\'':'"'
	if(n==224) return 'META|Command'
	if(n==229) return 'WIN IME'

	if(n==255) return 'Device-specific' //Dell Home button (Inspiron laptops)

	return null
}